using Microsoft.EntityFrameworkCore;
using TwilioSMSReceiver;
using TwilioSMSReceiver.Common.Handlers;
using TwilioSMSReceiver.Common.Interfaces;
using TwilioSMSReceiver.Common.Registrations;
using TwilioSMSReceiver.Data;

var builder = WebApplication.CreateBuilder(args);

// Add services to the container.

builder.Services.AddControllers().AddNewtonsoftJson(x => x.SerializerSettings.ReferenceLoopHandling = Newtonsoft.Json.ReferenceLoopHandling.Ignore);
// Learn more about configuring Swagger/OpenAPI at https://aka.ms/aspnetcore/swashbuckle
builder.Services.AddEndpointsApiExplorer();
builder.Services.AddSwaggerGen();

builder.Services.AddDbContext<SMSDbCtx>(options => {
    options.UseSqlite(builder.Configuration.GetConnectionString("SmsDBCtx"));
});
builder.Services.RegisterSMSExtensions();
builder.Services.AddLogging();
//builder.Services.AddSingleton<IMessageHandler>();
var app = builder.Build();

// Configure the HTTP request pipeline.
if (app.Environment.IsDevelopment())
{
    app.UseSwagger();
    app.UseSwaggerUI();
}

app.UseHttpsRedirection();

app.UseAuthorization();

app.MapControllers();

app.Run();
